from codequick import Route, Listitem, Script, Resolver
from resources.lib.kedon import getlink, quangcao, yttk, get_info_fs, gioithieu
from bs4 import BeautifulSoup
from urllib.parse import quote_plus
from concurrent.futures import ThreadPoolExecutor
from datetime import date
import re
td = date.today()
hn = td.strftime('%Y-%m-%d')
def get_info_tvhd(idk):
	t = f'https://thuvienhd.xyz/?feed=fsharejson&id={idk}'
	resp = getlink(t, t, 1000)
	if (resp is not None) and resp.json()['link']:
		try:
			d = resp.json()
			img = d['image']
			mota = d['description']
			ten = d['title'].replace('&&','-')
			return (ten, img, mota)
		except:
			return None
	else:
		return None
def process_url(idk):
	try:
		data = get_info_tvhd(idk)
		return idk, data
	except:
		return idk, None
def process_fs(url):
	try:
		data = get_info_fs(url)
		return url, data
	except:
		return url, None
@Route.register
def search_thuvienhd(plugin, search_query=None):
	yield []
	if search_query is None:
		pass
	else:
		try:
			sr = quote_plus(search_query)
			url = f'http://thuvienhd.xyz/?s={sr}'
			urlrf = 'https://thuvienhd.xyz'
			resp = getlink(url, urlrf, 1000)
			if (resp is not None):
				match = re.search(r'"nonce":"(.*?)"', resp.text)[1]
				urltv = f'http://thuvienhd.xyz/wp-json/dooplay/search/?nonce={match}&keyword={sr}'
				r = getlink(urltv, urlrf, 1000)
				if 'No results' in r.text:
					yield quangcao()
				else:
					rs = r.json().values()
					for k in rs:
						item = Listitem()
						item.label = k['title']
						item.info['mediatype'] = 'tvshow'
						item.info['trailer'] = yttk(k['title'])
						item.art['thumb'] = item.art['poster'] = k['img']
						item.set_callback(thuvienhd_linktk, k['url'])
						yield item
			else:
				yield quangcao()
		except:
			yield quangcao()
@Route.register
def index_thuvienhd(plugin):
	yield Listitem.search(search_thuvienhd)
	T = {'Phim lẻ': tvhd_phimle,
	'Phim bộ': tvhd_phimbo,
	'Nhạc': tvhd_nhac}
	dulieu = {
	'Phim mới':'http://thuvienhd.xyz/recent',
	'Thịnh hành':'http://thuvienhd.xyz/trending',
	'Thuyết minh':'http://thuvienhd.xyz/genre/thuyet-minh-tieng-viet',
	'Lồng tiếng':'http://thuvienhd.xyz/genre/long-tieng-tieng-viet',
	'H265':'http://thuvienhd.xyz/genre/h265',
	'3D':'http://thuvienhd.xyz/genre/3d',
	'4K':'http://thuvienhd.xyz/genre/4k',
	'ATV':'http://thuvienhd.xyz/genre/atv',
	'Bluray':'http://thuvienhd.xyz/genre/bluray-nguyen-goc',
	'TVB':'http://thuvienhd.xyz/genre/tvb',
	'Bộ sưu tập':'http://thuvienhd.xyz/genre/collection',
	'TV Shows':'http://thuvienhd.xyz/genre/tv-show',
	'TV':'http://thuvienhd.xyz/genre/tv',
	'Phim truyền hình':'http://thuvienhd.xyz/genre/tv-movie',
	'Phim 18':'http://thuvienhd.xyz/genre/18',
	}
	for k in T:
		item = Listitem()
		item.label = k
		item.info['mediatype'] = 'tvshow'
		item.art['thumb'] = item.art['poster'] = 'https://mi3s.top/thumb/fshare/tvhd.png'
		item.set_callback(T[k])
		yield item
	for h in dulieu:
		i1 = Listitem()
		i1.label = h
		i1.info['mediatype'] = 'tvshow'
		i1.art['thumb'] = i1.art['poster'] = 'https://mi3s.top/thumb/fshare/tvhd.png'
		i1.set_callback(thuvienhd_page, f'{dulieu[h]}/page/', 1)
		yield i1
@Route.register
def tvhd_phimle(plugin):
	dulieu = {
	'Mới nhất':'https://thuvienhd.xyz/genre/phim-le',
	'3D': 'https://thuvienhd.xyz/genre/3d',
	'4K': 'https://thuvienhd.xyz/genre/4k',
	'Âm Nhạc': 'https://thuvienhd.xyz/genre/am-nhac',
	'Ấn Độ': 'https://thuvienhd.xyz/genre/india',
	'Bản quyền': 'https://thuvienhd.xyz/genre/copyright',
	'Bí Ẩn': 'https://thuvienhd.xyz/genre/bi-an',
	'Cao Bồi': 'https://thuvienhd.xyz/genre/western',
	'Chiến Tranh': 'https://thuvienhd.xyz/genre/war',
	'Chính Kịch': 'https://thuvienhd.xyz/genre/chinh-kich',
	'Cổ Trang': 'https://thuvienhd.xyz/genre/co-trang-phim',
	'Gây cấn': 'https://thuvienhd.xyz/genre/gay-can',
	'Gia Đình': 'https://thuvienhd.xyz/genre/gia-dinh',
	'Hài': 'https://thuvienhd.xyz/genre/comedy',
	'Hàn Quốc': 'https://thuvienhd.xyz/genre/korean',
	'Hành Động': 'https://thuvienhd.xyz/genre/action',
	'Hình Sự': 'https://thuvienhd.xyz/genre/crime',
	'Hồi hộp': 'https://thuvienhd.xyz/genre/hoi-hop',
	'Hongkong': 'https://thuvienhd.xyz/genre/hongkong',
	'Huyền Bí': 'https://thuvienhd.xyz/genre/mystery',
	'Kinh Dị': 'https://thuvienhd.xyz/genre/horror',
	'Lãng Mạn': 'https://thuvienhd.xyz/genre/romance',
	'Lịch Sử': 'https://thuvienhd.xyz/genre/history',
	'Nhạc Kịch': 'https://thuvienhd.xyz/genre/nhac-kich',
	'Phiêu Lưu': 'https://thuvienhd.xyz/genre/adventure',
	'Rùng Rợn': 'https://thuvienhd.xyz/genre/thriller',
	'Tâm Lý': 'https://thuvienhd.xyz/genre/drama',
	'Thần Thoại': 'https://thuvienhd.xyz/genre/fantasy',
	'Thể Thao': 'https://thuvienhd.xyz/genre/the-thao',
	'Thiếu Nhi': 'https://thuvienhd.xyz/genre/family',
	'Tiểu Sử': 'https://thuvienhd.xyz/genre/tieu-su',
	'Tình Cảm': 'https://thuvienhd.xyz/genre/tinh-cam',
	'Tội Phạm': 'https://thuvienhd.xyz/genre/toi-pham',
	'Trinh Thám': 'https://thuvienhd.xyz/genre/trinh-tham',
	'Trung Quốc': 'https://thuvienhd.xyz/genre/trung-quoc-series',
	'Viễn Tưởng': 'https://thuvienhd.xyz/genre/sci-fi',
	'Việt Nam': 'https://thuvienhd.xyz/genre/vietnamese',
	'Võ Thuật': 'https://thuvienhd.xyz/genre/vo-thuat-phim-2',
	'Giáng Sinh': 'https://thuvienhd.xyz/genre/giang-sinh',
	'Phim Hoạt Hình': 'https://thuvienhd.xyz/genre/animation',
	'Phim Tài Liệu': 'https://thuvienhd.xyz/genre/documentary',
	'Phim': 'https://thuvienhd.xyz/genre/phim'
}
	for k in dulieu:
		item = Listitem()
		item.label = k
		item.info['mediatype'] = 'tvshow'
		item.art['thumb'] = item.art['poster'] = 'https://mi3s.top/thumb/fshare/tvhd.png'
		item.set_callback(thuvienhd_page, f'{dulieu[k]}/page/', 1)
		yield item
@Route.register
def tvhd_phimbo(plugin):
	dulieu = {
	'Mới nhất':'https://thuvienhd.xyz/genre/series',
	'Phim Bộ Nigeria': 'https://thuvienhd.xyz/genre/phi-bo-nigeria',
	'Phim Bộ Ả Rập': 'https://thuvienhd.xyz/genre/phim-bo-a-rap',
	'Phim Bộ Ai Cập': 'https://thuvienhd.xyz/genre/phim-bo-ai-cap',
	'Phim Bộ Ái Nhĩ Lan (Ireland)': 'https://thuvienhd.xyz/genre/phim-bo-ai-nhi-lan-ireland',
	'Phim Bộ Ấn Độ': 'https://thuvienhd.xyz/genre/phim-bo-an-do',
	'Phim bộ Anh': 'https://thuvienhd.xyz/genre/phim-bo-anh',
	'Phim Bộ Áo': 'https://thuvienhd.xyz/genre/phim-bo-ao',
	'Phim Bộ Argentina': 'https://thuvienhd.xyz/genre/phim-bo-argentina',
	'Phim Bộ Australia': 'https://thuvienhd.xyz/genre/phim-bo-australia',
	'Phim Bộ Ba Lan': 'https://thuvienhd.xyz/genre/phim-bo-ba-lan',
	'Phim Bộ Bỉ': 'https://thuvienhd.xyz/genre/phim-bo-bi',
	'Phim Bộ Bồ Đào Nha': 'https://thuvienhd.xyz/genre/phim-bo-bo-dao-nha',
	'Phim Bộ Brazil': 'https://thuvienhd.xyz/genre/phim-bo-brazil',
	'Phim Bộ Canada': 'https://thuvienhd.xyz/genre/phim-bo-canada',
	'Phim Bộ Chile': 'https://thuvienhd.xyz/genre/phim-bo-chile',
	'Phim Bộ Colombia': 'https://thuvienhd.xyz/genre/phim-bo-colombia',
	'Phim Bộ Đài Loan': 'https://thuvienhd.xyz/genre/phim-bo-dai-loan',
	'Phim Bộ Đan Mạch': 'https://thuvienhd.xyz/genre/phim-bo-dan-mach',
	'Phim Bộ Đức': 'https://thuvienhd.xyz/genre/phim-bo-duc',
	'Phim Bộ Hà Lan': 'https://thuvienhd.xyz/genre/phim-bo-ha-lan',
	'Phim Bộ Hàn': 'https://thuvienhd.xyz/genre/korean-series',
	'Phim Bộ Hongkong': 'https://thuvienhd.xyz/genre/hongkong-series',
	'Phim Bộ Iceland': 'https://thuvienhd.xyz/genre/phim-bo-iceland',
	'Phim Bộ Ireland': 'https://thuvienhd.xyz/genre/phim-bo-ireland',
	'Phim Bộ Israel': 'https://thuvienhd.xyz/genre/phim-bo-israel',
	'Phim Bộ Jordan': 'https://thuvienhd.xyz/genre/phim-bo-jordan',
	'Phim Bộ Mexico': 'https://thuvienhd.xyz/genre/phim-bo-mexico',
	'Phim Bộ Mỹ': 'https://thuvienhd.xyz/genre/us-tv-series',
	'Phim Bộ Na Uy': 'https://thuvienhd.xyz/genre/phim-bo-na-uy',
	'Phim Bộ Nam Phi': 'https://thuvienhd.xyz/genre/phim-bo-nam-phi',
	'Phim Bộ New Zealand': 'https://thuvienhd.xyz/genre/phim-bo-new-zealand',
	'Phim Bộ Nga': 'https://thuvienhd.xyz/genre/phim-bo-nga',
	'Phim Bộ Nhật Bản': 'https://thuvienhd.xyz/genre/phim-bo-nhat-ban',
	'Phim Bộ Phần Lan': 'https://thuvienhd.xyz/genre/phim-bo-phan-lan',
	'Phim Bộ Pháp': 'https://thuvienhd.xyz/genre/phim-bo-phap',
	'Phim Bộ Philippines': 'https://thuvienhd.xyz/genre/phim-bo-philippines',
	'Phim Bộ Romania': 'https://thuvienhd.xyz/genre/phim-bo-romania',
	'Phim Bộ Singapo': 'https://thuvienhd.xyz/genre/phim-bo-singapo',
	'Phim Bộ Tây Ban Nha': 'https://thuvienhd.xyz/genre/phim-bo-tay-ban-nha',
	'Phim Bộ Thái Lan': 'https://thuvienhd.xyz/genre/phim-bo-thai-lan',
	'Phim Bộ Thổ Nhĩ Kỳ': 'https://thuvienhd.xyz/genre/phim-bo-tho-nhi-ky',
	'Phim Bộ Thụy Điển': 'https://thuvienhd.xyz/genre/phim-bo-thuy-dien',
	'Phim Bộ Trung Quốc': 'https://thuvienhd.xyz/genre/phim-bo-trung-quoc',
	'Phim Bộ Việt Nam': 'https://thuvienhd.xyz/genre/phim-bo-viet-nam',
	'Phim Bộ Ý': 'https://thuvienhd.xyz/genre/phim-bo-y'
}
	for k in dulieu:
		item = Listitem()
		item.label = k
		item.info['mediatype'] = 'tvshow'
		item.art['thumb'] = item.art['poster'] = 'https://mi3s.top/thumb/fshare/tvhd.png'
		item.set_callback(thuvienhd_page, f'{dulieu[k]}/page/', 1)
		yield item
@Route.register
def tvhd_nhac(plugin):
	dulieu = {
	'Mới nhất':'https://thuvienhd.xyz/genre/music',
	'Chương Trình Xuân': 'https://thuvienhd.xyz/genre/chuong_trinh-xuan',
	'Lossless': 'https://thuvienhd.xyz/genre/lossless',
	'MV Châu Á': 'https://thuvienhd.xyz/genre/wp-chau-a',
	'MV Quốc Tế': 'https://thuvienhd.xyz/genre/wp-quoc-te',
	'MV Việt Nam': 'https://thuvienhd.xyz/genre/wp-viet-nam'
}
	for k in dulieu:
		item = Listitem()
		item.label = k
		item.info['mediatype'] = 'tvshow'
		item.art['thumb'] = item.art['poster'] = 'https://mi3s.top/thumb/fshare/tvhd.png'
		item.set_callback(thuvienhd_page, f'{dulieu[k]}/page/', 1)
		yield item
@Route.register
def thuvienhd_linktk(plugin, url=None):
	yield []
	if url is None:
		pass
	else:
		try:
			respx = getlink(url, url, 1000)
			if (respx is not None):
				idk = re.search(r"thuvienhd.xyz/\?p=(\d+)", respx.text)
				t = f'https://thuvienhd.xyz/?feed=fsharejson&id={idk[1]}'
				resp = getlink(t, t, 1000)
				if (resp is not None) and resp.json()['link']:
					d = resp.json()
					anh = d['image']
					mota = d['description']
					title = d['title']
					yield gioithieu(title, mota, anh)
					dl = d['link']
					urls = [k['link'] for k in dl if 'fshare.vn' in k['link']]
					length = len(urls)
					if length>0:
						with ThreadPoolExecutor(length) as ex:
							results = ex.map(process_fs, urls)
						for (link, data) in results:
							if data is not None:
								item = Listitem()
								item.label = data[0]
								item.info['plot'] = mota
								item.info['trailer'] = yttk(title)
								item.art['thumb'] = item.art['poster'] = anh
								item.context.script(Script.ref('/resources/lib/mkd/onfshare/ifshare:tfavo'), 'Thêm vào Fshare Favorite', link)
								if 'folder' in link:
									item.info['mediatype'] = 'tvshow'
									item.set_callback(Route.ref('/resources/lib/mkd/onfshare/ifshare:index_fs'), link, 0, anh)
								else:
									item.info['mediatype'] = 'episode'
									item.info['size'] = data[1]
									if Script.setting.get_string('taifshare') == 'true':
										item.context.script(Script.ref('/resources/lib/download:downloadfs'), 'Tải về', link)
									item.set_callback(Resolver.ref('/resources/lib/kedon:play_fs'), link, data[0])
								yield item
					else:
						yield quangcao()
				else:
					yield quangcao()
			else:
				yield quangcao()
		except:
			yield quangcao()
@Route.register
def thuvienhd_page(plugin, url=None, next_page=None):
	yield []
	if any((url is None, next_page is None)):
		pass
	else:
		try:
			trangtiep = f'{url}{next_page}'
			resp = getlink(trangtiep, trangtiep, 1000)
			if (resp is not None):
				soup = BeautifulSoup(resp.content, 'html.parser')
				s1 = [k['id'].split('-')[1] for k in soup.select('div.items article')]
				s2 = soup.select('div.pagination a')
				length = len(s1)
				if length>0:
					with ThreadPoolExecutor(length) as ex:
						results = ex.map(process_url, s1)
					for (l, data) in results:
						if data is not None:
							item = Listitem()
							item.label = data[0]
							item.info['plot'] = data[2]
							item.info['mediatype'] = 'tvshow'
							item.info['trailer'] = yttk(data[0])
							item.art['thumb'] = item.art['poster'] = data[1]
							item.set_callback(thuvienhd_link, l)
							yield item
					for checkpage in s2:
						if str(next_page + 1) in checkpage.get_text(strip=True):
							item1 = Listitem()
							item1.label = f'Trang {next_page + 1}'
							item1.info['mediatype'] = 'tvshow'
							item1.art['thumb'] = item1.art['poster'] = 'https://mi3s.top/thumb/next.png'
							item1.set_callback(thuvienhd_page, url, next_page + 1)
							yield item1
			else:
				yield quangcao()
		except:
			yield quangcao()
@Route.register
def thuvienhd_link(plugin, idk=None):
	yield []
	if idk is None:
		pass
	else:
		try:
			t = f'https://thuvienhd.xyz/?feed=fsharejson&id={idk}'
			resp = getlink(t, t, 1000)
			if (resp is not None) and resp.json()['link']:
				d = resp.json()
				anh = d['image']
				mota = d['description']
				title = d['title'].replace('&&','-')
				yield gioithieu(title, mota, anh)
				dl = d['link']
				urls = [k['link'] for k in dl if 'fshare.vn' in k['link']]
				length = len(urls)
				if length>0:
					with ThreadPoolExecutor(length) as ex:
						results = ex.map(process_fs, urls)
					for (link, data) in results:
						if data is not None:
							item = Listitem()
							item.label = data[0]
							item.info['plot'] = mota
							item.info['trailer'] = yttk(title)
							item.art['thumb'] = item.art['poster'] = anh
							item.context.script(Script.ref('/resources/lib/mkd/onfshare/ifshare:tfavo'), 'Thêm vào Fshare Favorite', link)
							if 'folder' in link:
								item.info['mediatype'] = 'tvshow'
								item.set_callback(Route.ref('/resources/lib/mkd/onfshare/ifshare:index_fs'), link, 0, anh)
							else:
								item.info['mediatype'] = 'episode'
								item.info['size'] = data[1]
								if Script.setting.get_string('taifshare') == 'true':
									item.context.script(Script.ref('/resources/lib/download:downloadfs'), 'Tải về', link)
								item.set_callback(Resolver.ref('/resources/lib/kedon:play_fs'), link, data[0])
							yield item
						else:
							yield quangcao()
				else:
					yield quangcao()
		except:
			yield quangcao()